﻿using System;
using System.IO;
using System.Collections.Generic;
namespace epitmenyado
{
  class Telek
  {
    public string TulajAsz { get; set; }
    public string Utca { get; set; }
    public string Hazszam { get; set; }
    public char Sav { get; set; }
    public int Terulet { get; set; }
    public Telek(string bejegyzes)
    {
      string[] adatok = bejegyzes.Split(' ', 5);
      TulajAsz = adatok[0];
      Utca = adatok[1];
      Hazszam = adatok[2];
      Sav = adatok[3][0];
      int ez;
	    Terulet = int.TryParse(adatok[4], out ez)? ez : 0;
    }
    public int Ado(int[] savdij, int alsohatar)
    {
      int alap = savdij[Sav - 65] * Terulet;
      return alap < alsohatar ? 0 : alap;
    }
  }

  class Lakos
  {
    public string asz;
    public int huf;
  }

  class Program
  {
    static List<Telek> lista = new List<Telek>();
    static int[] savAr = new int[3];

    static void Main()
    {
      F1_Beolvas();
      Console.Write("2. feladat. ");
      Console.WriteLine($"A mintában {lista.Count} adat szerepel");
      Console.Write("3. feladat. ");
      Console.Write("Egy tulajdonos adószáma: ");
      string adoszam = Console.ReadLine();
      if (F3_Kigyujt(adoszam) == 0)
        Console.WriteLine("Nem szerepel az adatállományban");
      Console.WriteLine("5. feladat.");
      F5_Savonkent();
      Console.WriteLine("6. feladat. A több sávba sorolt utcák:");
      F6_Tobbsavos();
      F7_Fizetendo();
      F7_Adok();
    }

    private static void F7_Fizetendo()
    {
      Dictionary<string, int> adozo = new Dictionary<string, int>();
      foreach (Telek telek in lista)
        if (adozo.ContainsKey(telek.TulajAsz))
          adozo[telek.TulajAsz] += telek.Ado(savAr, 10000);
        else
          adozo.Add(telek.TulajAsz, telek.Ado(savAr, 10000));
      StreamWriter ki = new StreamWriter("fizetendo.txt");
      foreach (KeyValuePair<string, int> item in adozo)
        ki.WriteLine($"{item.Key} {item.Value}");
      ki.Close();
    }


    private static void F7_Adok()
    {
      List<Lakos> adozo = new List<Lakos>();
      foreach (Telek telek in lista)
      {
        int ez;
        for (ez = 0; ez < adozo.Count && adozo[ez].asz != telek.TulajAsz; ez++)
          ;
        if (ez < adozo.Count)
          adozo[ez].huf += telek.Ado(savAr, 10000);
        else
        {
          Lakos uj = new Lakos();
          uj.asz = telek.TulajAsz;
          uj.huf = telek.Ado(savAr, 10000);
          adozo.Add(uj);
        }
      }
      StreamWriter ki = new StreamWriter("fizetendo2.txt");
      foreach (Lakos lakos in adozo)
        ki.WriteLine($"{lakos.asz} {lakos.huf}");
      ki.Close();
    }

    private static void F6_Tobbsavos()
    {
      for (int i = 0; i < lista.Count - 1; i++)
      {
        if (i == 0 || lista[i].Utca != lista[i - 1].Utca) /*utca eleje*/
        {
          bool egy = true;
          for (int k = i + 1; k < lista.Count && lista[i].Utca == lista[k].Utca && egy; k++)
            if (lista[i].Sav != lista[k].Sav)
            {
              Console.WriteLine(lista[i].Utca);
              egy = false;
            }
        }
      }
    }

    private static void F5_Savonkent()
    {
      int[] db = new int[3];
      int[] osszado = new int[3];
      foreach (Telek telek in lista)
      {
        db[telek.Sav - (int)'A']++;
        osszado[telek.Sav - (int)'A'] += ado(telek.Sav, telek.Terulet);
      }
      for (int i = 0; i < 3; i++)
        Console.WriteLine($"{(char)(i + 'A')} sávba {db[i],3} telek esik, az adó {osszado[i],10:N0} Ft.");
    }

    static int ado(char sav, int terulet)
    {
      int osszeg = savAr[sav - 65] * terulet;

      return osszeg < 10000 ? 0 : osszeg;
    }

    private static int F3_Kigyujt(string adoszam)
    {
      int db = 0;
      foreach (Telek telek in lista)
        if (telek.TulajAsz == adoszam)
        {
          Console.WriteLine("{0} utca {1}", telek.Utca, telek.Hazszam);
          db++;
        }
      return db;
    }

    private static void F1_Beolvas()
    {
      StreamReader be = new StreamReader("utca.txt");
      string[] sor = be.ReadLine().Split(' ', 3);
      for (int i = 0; i < 3; i++)
        savAr[i] = int.Parse(sor[i]);
      while (!be.EndOfStream)
        lista.Add(new Telek(be.ReadLine()));
      be.Close();
    }
  }
}
